<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="机器人账号" prop="accountName">
        <el-input v-model="queryParams.accountName" placeholder="请输入机器人账号" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="运行状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择运行状态" clearable>
          <el-option v-for="dict in dict.type.rebot_status" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleSyn"
          v-hasPermi="['business:ctRebot:syn']">同步机器人信息</el-button>
          <span style="color: red;"> 提示：搜索更新并非实时数据,同步为最新数据</span>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ctRebotList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" fixed="left" /> -->
      <el-table-column label="序号" width="55" align="center" fixed="left" >
        <template slot-scope="scope">
            {{ scope.$index + 1 }}
        </template>
      </el-table-column>
      <el-table-column label="机器人名称" align="center" prop="robotClientName" width="200"/>
      <!-- <el-table-column label="机器人Uuid信息" align="center" prop="robotClientUuid" width="300"/> -->
      <el-table-column label="运行状态" align="center" prop="status" width="100">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.rebot_status" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <!-- <el-table-column label="描述" align="center" prop="description" width="100"/>
      <el-table-column label="客户端系统账号" align="center" prop="windowsAccount" width="150"/> -->
      <el-table-column label="客户端ip" align="center" prop="clientIp" width="150"/>
      <!-- <el-table-column label="部门id" align="center" prop="deptId" width="100"/> -->
    <el-table-column label="创建者" align="center" fixed="right" prop="createBy" width="100"/>
      <el-table-column label="创建时间" align="center" fixed="right" prop="createTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
    <el-table-column label="更新者" align="center" fixed="right" prop="updateBy" width="100"/>
      <el-table-column label="更新时间" align="center" fixed="right" prop="updateTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
    <!-- <el-table-column label="备注" align="center" prop="remark"/> -->
      <el-table-column label="操作" align="center" width="150" fixed="right" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <!-- <el-button size="mini" type="text" icon="el-icon-edit" @click="handleSyn(scope.row)"
            v-hasPermi="['business:ctRebot:edit']">同步</el-button> -->
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改机器人管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="机器人账号" prop="accountName">
          <el-input v-model="form.accountName" placeholder="请输入机器人账号" />
        </el-form-item>
        <el-form-item label="机器人Uuid信息" prop="robotClientUuid">
          <el-input v-model="form.robotClientUuid" placeholder="请输入机器人Uuid信息" />
        </el-form-item>
        <el-form-item label="运行状态" prop="status">
          <el-select v-model="form.status" placeholder="请选择运行状态">
            <el-option v-for="dict in dict.type.rebot_status" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="描述" prop="description">
          <el-input v-model="form.description" placeholder="请输入描述" />
        </el-form-item>
        <el-form-item label="客户端ip" prop="clientIp">
          <el-input v-model="form.clientIp" placeholder="请输入客户端ip" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listCtRebot, getCtRebot, delCtRebot, addCtRebot, updateCtRebot, syn } from "@/api/business/ctRebot";

export default {
  name: "CtRebot",
  dicts: ['rebot_status'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 机器人管理表格数据
      ctRebotList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        accountName: null,
        status: null,
        description: null,
        clientIp: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 同步 */
    handleSyn() {
      syn().then(res => {
        this.getList()
        this.$modal.msgSuccess("操作成功");
      });
    },
    /** 查询机器人管理列表 */
    getList() {
      this.loading = true;
      listCtRebot(this.queryParams).then(response => {
        this.ctRebotList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        accountName: null,
        robotClientUuid: null,
        status: null,
        description: null,
        clientIp: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
        deleted: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加机器人管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getCtRebot(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改机器人管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCtRebot(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCtRebot(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除机器人管理编号为"' + ids + '"的数据项？').then(function () {
        return delCtRebot(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('business/ctRebot/export', {
        ...this.queryParams
      }, `ctRebot_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
